package jp.co.kayo.android.localplayer;
/***
 * Copyright (c) 2010-2012 yokmama. All rights reserved.
 * 
 *      This program is free software; you can redistribute it and/or modify it under
 *      the terms of the GNU General Public License as published by the Free Software
 *      Foundation; either version 2 of the License, or (at your option) any later
 *      version.
 *      
 *      This program is distributed in the hope that it will be useful, but WITHOUT
 *      ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 *      FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 *      details.
 *      
 *      You should have received a copy of the GNU General Public License along with
 *      this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 *      Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

import jp.co.kayo.android.localplayer.R;
import jp.co.kayo.android.localplayer.consts.SystemConsts;
import jp.co.kayo.android.localplayer.util.ThemeHelper;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.webkit.WebView;
import android.webkit.WebViewClient;

public class AuthActivity extends Activity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        new ThemeHelper().selectTheme(this);
        super.onCreate(savedInstanceState);
        setContentView(R.layout.login);

        WebView webView = (WebView) findViewById(R.id.WebView01);

        // WebViewを使って承認処理をします、承認後遷移先のページで
        // パラメータの取得処理をしています。
        webView.setWebViewClient(new WebViewClient() {
            public void onPageFinished(WebView view, String url) {
                super.onPageFinished(view, url);
                // 遷移先のURLがCALLBACK URLで始まっていれば認証成功
                if (url != null && url.startsWith(SystemConsts.CALLBACK_URL)) {
                    String[] urlParameters = url.split("\\?")[1].split("&");

                    String oauthVerifier = "";
                    // oauth_verifierをURLパラメータから取得する
                    if (urlParameters.length > 0
                            && urlParameters[0]
                                    .startsWith(SystemConsts.KEY_OAUTH_VERIFIER)) {
                        oauthVerifier = urlParameters[0].split("=")[1];
                    } else if (urlParameters.length > 1
                            && urlParameters[1]
                                    .startsWith(SystemConsts.KEY_OAUTH_VERIFIER)) {
                        oauthVerifier = urlParameters[1].split("=")[1];
                    }

                    if (oauthVerifier.length() > 0) {
                        Intent intent = getIntent();
                        intent.putExtra(SystemConsts.KEY_OAUTH_VERIFIER,
                                oauthVerifier);

                        setResult(Activity.RESULT_OK, intent);
                    } else {
                        Intent intent = getIntent();
                        setResult(Activity.RESULT_CANCELED, intent);
                    }
                    finish();
                }
            }
        });

        // 認証ページを表示。
        webView.loadUrl(this.getIntent().getExtras().getString("auth_url"));
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
    }
}
