package jp.co.kayo.android.localplayer;

/***
 * Copyright (c) 2010-2012 yokmama. All rights reserved.
 * 
 *      This program is free software; you can redistribute it and/or modify it under
 *      the terms of the GNU General Public License as published by the Free Software
 *      Foundation; either version 2 of the License, or (at your option) any later
 *      version.
 *      
 *      This program is distributed in the hope that it will be useful, but WITHOUT
 *      ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 *      FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 *      details.
 *      
 *      You should have received a copy of the GNU General Public License along with
 *      this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 *      Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

import java.util.Hashtable;
import java.util.Timer;

import jp.co.kayo.android.localplayer.appwidget.AppWidgetHelper;
import jp.co.kayo.android.localplayer.consts.MediaConsts;
import jp.co.kayo.android.localplayer.consts.SystemConsts;
import jp.co.kayo.android.localplayer.consts.MediaConsts.AudioMedia;
import jp.co.kayo.android.localplayer.core.ContentManager;
import jp.co.kayo.android.localplayer.core.ContextMenuFragment;
import jp.co.kayo.android.localplayer.provider.ContentsUtils;
import jp.co.kayo.android.localplayer.service.IMediaPlayerService;
import jp.co.kayo.android.localplayer.service.IMediaPlayerServiceCallback;
import jp.co.kayo.android.localplayer.service.MediaPlayerService;
import jp.co.kayo.android.localplayer.ui.ArtistListFragment;
import jp.co.kayo.android.localplayer.ui.ControlFragment;
import jp.co.kayo.android.localplayer.ui.GenresListFragment;
import jp.co.kayo.android.localplayer.ui.IProgressView;
import jp.co.kayo.android.localplayer.ui.dialog.DeletePlaylistDialog;
import jp.co.kayo.android.localplayer.ui.dialog.OpenPlaylistDialog;
import jp.co.kayo.android.localplayer.ui.dialog.SavePlaylistDialog;
import jp.co.kayo.android.localplayer.util.Logger;
import jp.co.kayo.android.localplayer.util.StrictHelper;
import jp.co.kayo.android.localplayer.util.ThemeHelper;
import jp.co.kayo.android.localplayer.util.ViewCache;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentTransaction;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.ContentObserver;
import android.media.AudioManager;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.os.RemoteException;
import android.os.ResultReceiver;
import android.preference.PreferenceManager;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.Window;
import android.view.WindowManager.LayoutParams;

public class SubListActivity extends BaseActivity {
    long ADVIEW_ELPASTIME = 1000 * 60 * 60;
    long adtime = 0;
    Timer adtimer;
    SharedPreferences pref;
    ViewCache mViewCache;
    final int MAX_IMAGE_COUNT = 100;
    Handler mHandler = new Handler();

    private ResultReceiver mReciever = null;

    IMediaPlayerServiceCallback.Stub mCallback = new IMediaPlayerServiceCallback.Stub() {
        ControlFragment control;

        ControlFragment getControll() {
            if (control == null) {
                FragmentManager m = getSupportFragmentManager();
                control = (ControlFragment) m
                        .findFragmentByTag(SystemConsts.TAG_CONTROL);
            }
            return control;
        }

        @Override
        public void updateView(final boolean updatelist) throws RemoteException {
            Logger.d("updateView=" + updatelist);
            // もし、コントロール部分が表示されているならリストを更新してあげて
            if (mHandler != null) {
                mHandler.post(new Runnable() {
                    @Override
                    public void run() {
                        // AlbumList,ArtistList,Song等
                        ControlFragment control = getControll();
                        if (mBinder != null) {
                            try {
                                long media_id = mBinder.getMediaId();
                                mViewCache.setPosition(mBinder.getPosition(),
                                        media_id, mBinder.getPrefetchId());
                            } catch (RemoteException e) {
                            }
                        }

                        if (control != null) {
                            control.updateView();
                        }

                        ContentManager fragment = (ContentManager) getSupportFragmentManager()
                                .findFragmentByTag(SystemConsts.TAG_CONTENTS);
                        if (fragment != null) {
                            fragment.changedMedia();
                        }
                    }
                });
            }
        }

        @Override
        public void updateList() throws RemoteException {
            // もし、再生中のフラグメントが表示されているならリストを更新してあげて
        }

        @Override
        public void onBufferingUpdate(int percent) throws RemoteException {
            // バッファリング中のプログレスバーですよぉ
            ControlFragment f = getControll();
            if (f != null) {
                f.onBufferingUpdate(percent);
            }
        }

        @Override
        public void startProgress(long max) throws RemoteException {
            ContentManager current = (ContentManager) getSupportFragmentManager()
                    .findFragmentByTag(SystemConsts.TAG_CONTENTS);
            if (current != null && current instanceof IProgressView) {
                ((IProgressView) current).startProgress(max);
            }
        }

        @Override
        public void stopProgress() throws RemoteException {
            ContentManager current = (ContentManager) getSupportFragmentManager()
                    .findFragmentByTag(SystemConsts.TAG_CONTENTS);
            if (current != null && current instanceof IProgressView) {
                ((IProgressView) current).stopProgress();
            }
        }

        @Override
        public void progress(long pos, long max) throws RemoteException {
            ContentManager current = (ContentManager) getSupportFragmentManager()
                    .findFragmentByTag(SystemConsts.TAG_CONTENTS);
            if (current != null && current instanceof IProgressView) {
                ((IProgressView) current).progress(pos, max);
            }
        }
    };

    ContentObserver mMediaContentObserver = new ContentObserver(new Handler()) {
        @Override
        public void onChange(boolean selfChange) {
            super.onChange(selfChange);
            // データベースに変更があったときに呼び出したい処理を書く
            ContentManager fragment = (ContentManager) getSupportFragmentManager()
                    .findFragmentByTag(SystemConsts.TAG_CONTENTS);
            if (fragment != null) {
                fragment.reload();
            }
        }
    };

    @Override
    public void setActionBarSubTitle(int stat) {
        if ((stat & AppWidgetHelper.FLG_PLAY) > 0) {
            IMediaPlayerService binder = getBinder();
            long media_id;
            try {
                media_id = binder.getMediaId();
                if (media_id > 0) {
                    Hashtable<String, String> tbl1 = ContentsUtils.getMedia(
                            this, new String[] { AudioMedia.ALBUM,
                                    AudioMedia.ALBUM_KEY, AudioMedia.ARTIST,
                                    AudioMedia.TITLE }, media_id);
                    String title = tbl1.get(AudioMedia.TITLE);
                    String artist = tbl1.get(AudioMedia.ARTIST);
                    getSupportActionBar().setSubtitle(title + " - " + artist);
                } else {
                    int pos = binder.getPosition();
                    String[] values = binder.getMediaD(pos);
                    if (values != null) {
                        String title = values[0];
                        String artist = values[2];
                        getSupportActionBar().setSubtitle(
                                title + " - " + artist);
                    }
                }
            } catch (RemoteException e) {
            }
        } else {
            getSupportActionBar().setSubtitle(getString(R.string.hello));
        }
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        new ThemeHelper().selectTheme(this);
        StrictHelper.registStrictMode();
        requestWindowFeature(Window.FEATURE_INDETERMINATE_PROGRESS);

        super.onCreate(savedInstanceState);

        Logger.d("SublistOnCreate");

        hideProgressBar();

        pref = PreferenceManager.getDefaultSharedPreferences(this);
        setContentView(R.layout.main_sub);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        hideProgressBar();
        getSupportActionBar().setSubtitle(getString(R.string.hello));

        // Audio Volume
        setVolumeControlStream(AudioManager.STREAM_MUSIC);

        getWindow().setSoftInputMode(
                LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);

        mReciever = new ResultReceiver(mHandler) {
            @Override
            protected void onReceiveResult(int resultCode, Bundle resultData) {
                super.onReceiveResult(resultCode, resultData);
                if (resultCode == 0 && resultData != null) {
                    String colname = resultData.getString("colname");
                    String key = resultData.getString("key");
                    getContentResolver().delete(
                            MediaConsts.PLAYLIST_CONTENT_URI,
                            colname + " = ? ", new String[] { key });
                }
            }
        };

        // ContentResolver
        getContentResolver().registerContentObserver(
                MediaConsts.MEDIA_CONTENT_URI, true, mMediaContentObserver);

        mViewCache = (ViewCache) getSupportFragmentManager().findFragmentByTag(
                SystemConsts.TAG_CACHE);

        // load list
        Intent intent = getIntent();
        if (intent != null) {
            Bundle params = intent.getExtras();
            if (params != null) {
                String subtype = params
                        .getString(SystemConsts.KEY_LIST_SUBTYPE);
                String selectedtitle = params
                        .getString(SystemConsts.KEY_LIST_TITLE);
                String selectedkey = params
                        .getString(SystemConsts.KEY_LIST_KEY);
                int max = params.getInt(SystemConsts.KEY_LIST_MAX);

                Bundle args = new Bundle();
                args.putString("selectedkey", selectedkey);
                args.putString("selectedtitle", selectedtitle);
                args.putInt("listmax", max);

                if (getSupportFragmentManager().findFragmentByTag(
                        SystemConsts.TAG_CONTENTS) == null) {
                    FragmentTransaction t = getSupportFragmentManager()
                            .beginTransaction();
                    if (subtype.equals(SystemConsts.PRM_ARTISTLIST)) {
                        ArtistListFragment fg = new ArtistListFragment();
                        fg.setArguments(args);
                        t.add(R.id.subcontents, fg, SystemConsts.TAG_CONTENTS);
                    } else {
                        GenresListFragment fg = new GenresListFragment();
                        fg.setArguments(args);
                        t.add(R.id.subcontents, fg, SystemConsts.TAG_CONTENTS);
                    }
                    t.commit();
                }
            }
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        getContentResolver().unregisterContentObserver(mMediaContentObserver);

        ViewCache.clearImage();
    }

    @Override
    protected void onPause() {
        super.onPause();

        if (mBinder != null) {
            try {
                mBinder.unregisterCallback(mCallback);
                mBinder = null;
            } catch (RemoteException e) {
            }
            unbindService(mConnection);
        }
    }

    @Override
    protected void onResume() {
        super.onResume();

        // 音楽サービスとの接続
        if (mBinder == null) {
            Intent service = new Intent(this, MediaPlayerService.class);
            // startService(service);
            bindService(service, mConnection, BIND_AUTO_CREATE);
        }

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getSupportMenuInflater();
        inflater.inflate(R.menu.sub_menu_items, menu);
        return true;
    }

    @Override
    public boolean onPrepareOptionsMenu(Menu menu) {
        if (menu == null) {
            return super.onPrepareOptionsMenu(menu);
        }
        MenuItem item = menu.findItem(R.id.mnu_equalizer);
        if (item != null) {
            item.setVisible(Build.VERSION.SDK_INT >= 9).setEnabled(
                    Build.VERSION.SDK_INT >= 9);
        }
        menu.findItem(R.id.mnu_reload)
                .setVisible(!ContentsUtils.isSDCard(pref))
                .setEnabled(!ContentsUtils.isSDCard(pref));

        return super.onPrepareOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        try {
            switch (item.getItemId()) {
            case android.R.id.home: {
                finish();
                return true;
            }
            case R.id.mnu_playlist: {
                Intent intent = new Intent(this, MainActivity.class);
                intent.setAction(SystemConsts.MAIN_ACITON_SHOWPLAYLIST);
                startActivity(intent);
                return true;
            }
            case R.id.mnu_config: {
                // 設定画面
                Intent intent = new Intent(this, ConfigActivity.class);
                startActivityForResult(intent, SystemConsts.REQUEST_CONFIG);
                return true;
            }
            case R.id.mnu_equalizer: {
                // イコライザー画面
                Intent intent = new Intent(this, EqualizerActivity.class);
                startActivity(intent);
                return true;
            }
            case R.id.mnu_search: {
                onSearchRequested();
                return true;
            }
            case R.id.mnu_reload: {
                Fragment f = getSupportFragmentManager().findFragmentByTag(
                        SystemConsts.TAG_CONTENTS);
                if (f != null) {
                    if (f instanceof ArtistListFragment) {
                        ((ArtistListFragment) f).reload();
                    } else {
                        ((GenresListFragment) f).reload();
                    }
                }

                return true;
            }
            case R.id.mnu_share: {
                ControlFragment control = (ControlFragment) getSupportFragmentManager()
                        .findFragmentByTag(SystemConsts.TAG_CONTROL);
                if (control != null) {
                    control.share();
                }
                return true;
            }
            default: {
            }
            }
            return super.onOptionsItemSelected(item);
        } finally {
        }
    }

    @Override
    public boolean dispatchKeyEvent(KeyEvent event) {
        if (event.getAction() == KeyEvent.ACTION_DOWN) {
            if (event.getKeyCode() == KeyEvent.KEYCODE_BACK) {
                Fragment fragment = getSupportFragmentManager()
                        .findFragmentByTag(SystemConsts.TAG_CONTENTS);
                if (fragment != null) {
                    if (fragment instanceof ContextMenuFragment) {
                        ContextMenuFragment f = (ContextMenuFragment) fragment;
                        if (f.onBackPressed()) {
                            return true;
                        }
                    }
                }
            }
        }
        return super.dispatchKeyEvent(event);
    }

    @Override
    public IMediaPlayerService getBinder() {
        return mBinder;
    }

    public void reload() {
    }

    @Override
    IMediaPlayerServiceCallback getCallBack() {
        // TODO Auto-generated method stub
        return mCallback;
    }

    @Override
    ContentManager getNeedReloadView() {
        return null;
    }

    @Override
    ViewCache getViewCache() {
        return mViewCache;
    }

    @Override
    Handler getHandler() {
        return mHandler;
    }
}
