package jp.co.kayo.android.localplayer.service;
/***
 * Copyright (c) 2010-2012 yokmama. All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 */

import java.io.File;
import java.util.Hashtable;

import jp.co.kayo.android.localplayer.R;
import jp.co.kayo.android.localplayer.appwidget.AppWidgetHelper;
import jp.co.kayo.android.localplayer.consts.MediaConsts.AudioAlbum;
import jp.co.kayo.android.localplayer.consts.MediaConsts.AudioMedia;
import jp.co.kayo.android.localplayer.util.Funcs;
import android.app.Notification;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.media.MediaPlayer;
import android.net.Uri;
import android.widget.RemoteViews;

public class MediaPlayerHelper {

    public static int getAudioSessionId(MediaPlayer mp) {
        return mp.getAudioSessionId();
    }

    public static void setCustomizedNotify(MediaPlayerService service,
            Notification notification, Hashtable<String, String> tbl1,
            Hashtable<String, String> tbl2, Bitmap bitmap) {
        try {
            /*if (bitmap == null) {
                String album = tbl2 != null ? tbl2.get(AudioAlbum.ALBUM) : tbl1
                        .get(AudioMedia.ALBUM);
                String artist = tbl2 != null ? tbl2.get(AudioAlbum.ARTIST)
                        : tbl1.get(AudioMedia.ARTIST);
                Integer key = AppWidgetHelper.getAlbumKey(album, artist);
                File file = AppWidgetHelper.createAlbumArtFile(key);
                if (file != null && file.exists()) {
                    bitmap = AudioFocus.loadBitmap(service, Uri.fromFile(file), 128);
//                            android.R.dimen.notification_large_icon_height);
                }
            }
            if (bitmap == null) {
                bitmap = BitmapFactory.decodeResource(service.getResources(),
                        R.drawable.appicon);
            }*/

            notification.largeIcon = bitmap;

            RemoteViews remoteView = new RemoteViews(service.getPackageName(),
                    R.layout.statusbar);
            remoteView.setOnClickPendingIntent(R.id.btnPlay, service
                    .createIntent(service, AppWidgetHelper.CALL_PLAY_PAUSE));
            remoteView.setOnClickPendingIntent(R.id.btnFf,
                    service.createIntent(service, AppWidgetHelper.CALL_FF));
//            remoteView.setOnClickPendingIntent(R.id.btnRew,
//                    service.createIntent(service, AppWidgetHelper.CALL_REW));
            remoteView.setInt(R.id.btnPlay, "setBackgroundResource",
                    R.drawable.widget_pause);
            remoteView.setTextViewText(R.id.textTitle,
                    Funcs.trimString(tbl1.get(AudioMedia.TITLE)));
            remoteView.setTextViewText(R.id.textArtist,
                    Funcs.trimString(tbl1.get(AudioMedia.ARTIST)));
            remoteView.setTextViewText(R.id.textTime, Funcs
                    .makeTimeString(Funcs.parseLong(tbl1
                            .get(AudioMedia.DURATION))));

            notification.contentView = remoteView;
        } finally {
            // (bitmap!=null){
            // bitmap.recycle();
            bitmap = null;
            // }
        }
    }

}
