package jp.co.kayo.android.localplayer.ui;
/***
 * Copyright (c) 2010-2012 yokmama. All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 */

import java.util.HashMap;

import jp.co.kayo.android.localplayer.R;
import jp.co.kayo.android.localplayer.consts.MediaConsts.FileMedia;
import jp.co.kayo.android.localplayer.core.ViewHolder;
import jp.co.kayo.android.localplayer.util.ViewCache;
import android.content.Context;
import android.database.Cursor;
import android.os.Handler;
import android.text.format.DateFormat;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

public class FileListViewAdapter extends IndexCursorAdapter {
    LayoutInflater inflator;
    Handler handler = new Handler();
    java.text.DateFormat format;
    HashMap<String, String> names = new HashMap<String, String>();

    public FileListViewAdapter(Context context, Cursor c, ViewCache cache,
            String cname) {
        super(context, c, true, cache, cname);
        format = DateFormat.getMediumDateFormat(context);

        names.put("folder", context.getString(R.string.txt_type_folder));
        names.put("audio", context.getString(R.string.txt_type_audio));
        names.put("zip", context.getString(R.string.txt_type_zip));
    }

    public LayoutInflater getInflator(Context context) {
        if (inflator == null) {
            inflator = (LayoutInflater) context
                    .getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        }
        return inflator;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        View view = super.getView(position, convertView, parent);
        ViewHolder holder = (ViewHolder) view.getTag();
        if (position % 2 == 1) {
            holder.getBackground().setVisibility(View.GONE);
        } else {
            holder.getBackground().setVisibility(View.VISIBLE);
        }

        return view;
    }

    @Override
    public void bindView(View view, Context context, Cursor cursor) {
        ViewHolder holder = (ViewHolder) view.getTag();
        long id = cursor.getLong(cursor.getColumnIndex(FileMedia._ID));
        String title = cursor.getString(cursor.getColumnIndex(FileMedia.TITLE));
        String type = cursor.getString(cursor.getColumnIndex(FileMedia.TYPE));
        long modified = cursor.getLong(cursor
                .getColumnIndex(FileMedia.DATE_MODIFIED));

        holder.setPotision(cursor.getPosition());
        holder.getText2().setText(title);
        holder.getText3().setText(names.get(type));
        holder.getText4().setText(format.format(modified));
    }

    @Override
    public View newView(Context context, Cursor cursor, ViewGroup parent) {
        View v = getInflator(context).inflate(R.layout.text_list_row5, parent,
                false);
        ViewHolder holder = new ViewHolder();
        holder.setText2((TextView) v.findViewById(R.id.text2));
        holder.setText3((TextView) v.findViewById(R.id.text3));
        holder.setText4((TextView) v.findViewById(R.id.text4));
        holder.setBackground(v.findViewById(R.id.background));
        v.setTag(holder);
        return v;
    }

    public String getIndexbar() {
        return indexbar;
    }
}
