package jp.co.kayo.android.localplayer.ui.plugin;
/***
 * Copyright (c) 2010-2012 yokmama. All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 */

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Rect;
import android.util.AttributeSet;
import android.view.View;

public class AlbumArt extends View {
    private Bitmap bmp;

    // private Bitmap clone;

    public AlbumArt(Context context, AttributeSet attrs, int defStyle) {
        super(context, attrs, defStyle);
    }

    public AlbumArt(Context context, AttributeSet attrs) {
        super(context, attrs);
    }

    public AlbumArt(Context context) {
        super(context);
    }

    public void setImage(Bitmap b) {
        bmp = b;
        invalidate();
    }

    @Override
    protected void onDraw(Canvas canvas) {
        super.onDraw(canvas);

        canvas.drawColor(Color.BLACK);

        if (bmp != null) {
            // 描画元の矩形イメージ
            Rect src = new Rect(0, 0, bmp.getWidth(), bmp.getHeight());
            // 描画先の矩形イメージ
            Rect dst = new Rect(0, 0, getWidth(), getHeight());
            canvas.drawBitmap(bmp, src, dst, null);
        }
    }
}
