package jp.co.kayo.android.localplayer.util;
/***
 * Copyright (c) 2010-2012 yokmama. All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 */

import android.content.Context;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.preference.PreferenceManager;
import android.widget.GridView;
import android.widget.ListView;

public class FragmentUtil {

    public static void saveState(Context context, GridView gridview, String tag) {
        SharedPreferences pref = PreferenceManager
                .getDefaultSharedPreferences(context);
        Editor edit = pref.edit();
        edit.putInt(tag + ".FirstVisiblePosition",
                gridview.getFirstVisiblePosition());
        edit.commit();
    }

    public static void saveState(Context context, ListView listview, String tag) {
        SharedPreferences pref = PreferenceManager
                .getDefaultSharedPreferences(context);
        Editor edit = pref.edit();
        edit.putInt(tag + ".FirstVisiblePosition",
                listview.getFirstVisiblePosition());
        edit.putInt(tag + ".Top", listview.getChildAt(0) != null ? listview
                .getChildAt(0).getTop() : 0);
        edit.commit();
    }

    public static void restoreState(Context context, GridView gridview,
            String tag) {
        SharedPreferences pref = PreferenceManager
                .getDefaultSharedPreferences(context);
        int firstVisiblePosition = pref
                .getInt(tag + ".FirstVisiblePosition", 0);
        if (firstVisiblePosition > 0) {
            gridview.setSelection(firstVisiblePosition);
        }
    }

    public static void restoreState(Context context, ListView listview,
            String tag) {
        SharedPreferences pref = PreferenceManager
                .getDefaultSharedPreferences(context);
        int firstVisiblePosition = pref
                .getInt(tag + ".FirstVisiblePosition", 0);
        int top = pref.getInt(tag + ".Top", 0);
        if (firstVisiblePosition > 0) {
            listview.setSelectionFromTop(firstVisiblePosition, top);
        }
    }
}
