package jp.co.kayo.android.localplayer.util.bean;
/***
 * Copyright (c) 2010-2012 yokmama. All rights reserved.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 */

import java.io.Serializable;

import android.os.Parcel;
import android.os.Parcelable;

public class MediaData implements Parcelable, Serializable {
    private static final long serialVersionUID = 8531245739641223373L;

    public long id = -1;
    public long duration = 0;
    public String data = null;
    public String title = null;
    public String album = null;
    public String artist = null;

    public MediaData(long id, long duration, String data) {
        this.id = id;
        this.duration = duration;
        this.data = data;
    }

    public MediaData(long id, long duration, String title, String album,
            String artist, String data) {
        this.id = id;
        this.duration = duration;
        this.data = data;
        this.title = title;
        this.artist = artist;
        this.album = album;
    }

    public MediaData(Parcel per) {
        id = per.readLong();
        duration = per.readLong();
        data = per.readString();
    }

    public static final Parcelable.Creator<MediaData> CREATOR = new Parcelable.Creator<MediaData>() {
        public MediaData createFromParcel(Parcel in) {
            return new MediaData(in);
        }

        public MediaData[] newArray(int size) {
            return new MediaData[size];
        }
    };

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeLong(id);
        dest.writeLong(duration);
        dest.writeString(data);
    }

    @Override
    public int describeContents() {
        return 0;
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public long getDuration() {
        return duration;
    }

    public void setDuration(long duration) {
        this.duration = duration;
    }

    public String getData() {
        return data;
    }

    public void setData(String data) {
        this.data = data;
    }
}
